from nile.api.v1 import (
    aggregators as na,
    filters as nf,
    extractors as ne,
    grouping as ng,
    clusters,
    files,
    statface,
    Record,
    Template,
    Path
)

from qb2.api.v1 import filters as sf
from qb2.api.v1 import QB2, extractors as se
import pandas as pd
import datetime
import requests
import numpy as np
import datetime

def parse_query(x, y):
        if y == 'af_search' or y == 'first_search_event':
            for par in x.replace('"', '').split(','):
                if 'af_search_string' in par:
                    return par.split(':')[1].replace('}', '')
def parse_revenue(x, y):
        if y == 'af_search' or y == 'first_search_event':
            for par in x.replace('"', '').split(','):
                if 'af_revenue' in par:
                    return par.split(':')[1].replace('}', '')
def parse_currency(x, y):
        if y == 'af_search' or y == 'first_search_event':
            for par in x.replace('"', '').split(','):
                if 'af_currency' in par:
                    return par.split(':')[1].replace('}', '')
def rename_event(x):
    if 'search' in str(x):
        return 'search'
    else:
        return x
def media(x):
    if x == None:
        return 'Unknown'
    elif str(x).lower() == 'null' or str(x).lower() == 'organic':
        return 'Organic'
    elif 'ya_' in str(x).lower():
        return 'Portal'
    elif '_int' in str(x).lower():
        return 'Paid'
    else:
        return 'Other'
def media1(x):
    if x == None:
        return 'Unknown'
    elif str(x).lower() == 'null' or str(x).lower() == 'organic':
        return 'Organic'
    else:
        return str(x).lower()
def week_start(x):
    try:
        return str(datetime.datetime.strptime(str(x), '%Y-%m-%d') - datetime.timedelta(days=datetime.datetime.strptime(str(x), '%Y-%m-%d').weekday())).split(' ')[0]
    except:
        return None
def month_start(x):
    try:
        return str(datetime.datetime.strptime(str(x), '%Y-%m-%d').replace(day=1)).split(' ')[0]
    except:
        return None
def install_day(x,y):
    if str(x) == str(y):
        return 'New'
    else:
        return 'Old'
def install_month(x,y):
    if str(x) == str(y):
        return 'New'
    else:
        return 'Old'
def install_week(x,y):
    if str(x) == str(y):
        return 'New'
    else:
        return 'Old'
def d_delta(x, y):
    try:
        t = datetime.datetime.strptime(str(x), '%Y-%m-%d') - datetime.datetime.strptime(str(y), '%Y-%m-%d')
        return t.days
    except:
        return None
def w_delta(x, y):
    try:
        t = datetime.datetime.strptime(str(x), '%Y-%m-%d') - datetime.datetime.strptime(str(y), '%Y-%m-%d')
        return int(t.days/7)
    except:
        return None
def m_delta(x, y):
    try:
        return (datetime.datetime.strptime(str(x), '%Y-%m-%d').year - datetime.datetime.strptime(str(y), '%Y-%m-%d').year)*12 + datetime.datetime.strptime(str(x), '%Y-%m-%d').month - datetime.datetime.strptime(str(y), '%Y-%m-%d').month
    except:
        return None
def get_app_name(x):
    if str(x) == 'ru.yandex.searchplugin':
        return 'Search App Android'
    elif str(x) == 'id1050704155':
        return 'Search App IOS'
    elif str(x) == 'com.yandex.browser':
        return 'YaBro Android'
    elif str(x) == 'id574939428':
        return 'YaBro iPad'
    else:
        return 'YaBro iPhone'
def dd(x):
    if not type(x) == int and not type(x) == float:
        return 0
    else:
        return x
enddate = datetime.datetime.now() - datetime.timedelta(days=1)
startdate = datetime.datetime.now() - datetime.timedelta(days=8)
enddate = str(enddate).split(' ')[0]
startdate = str(startdate).split(' ')[0]
startdate = '2016-02-09'
cluster = clusters.Hahn(pool='mobile-research', token='a6575e1e15b0475fb8d8564beaa60f23').env(
    templates=dict(
        job_root='home/turkey-analytics/ktereshin',
        dates='{%s..%s}' % (startdate, enddate)
    )
)
job = cluster.job()
searches = job.table('$job_root/appsflyer_dash/searches').groupby('appsflyer_device_id', 'event_date', 'event_month', 'event_week').aggregate(searches=na.count())
installs = job.table('$job_root/appsflyer_dash/appsflyer_installs')
installs = installs.join(searches, by='appsflyer_device_id', type='left')
installs = installs.project(ne.all(), days_delta = ne.custom(d_delta, 'event_date', 'install_date'),
                            weeks_delta = ne.custom(w_delta, 'event_week', 'install_week'),
                            months_delta = ne.custom(m_delta, 'event_month', 'install_month'),
install_weeks_delta = ne.custom(w_delta, 'event_date', 'install_date'),
                            install_months_delta = ne.custom(m_delta, 'event_date', 'install_date'),
searches = ne.custom(dd, 'searches'))
installs = installs.put('$job_root/appsflyer_dash/install_searches_cohort')
job.run()
