from nile.api.v1 import (
    aggregators as na,
    filters as nf,
    extractors as ne,
    grouping as ng,
    clusters,
    files,
    statface,
    Record,
    Template,
    Path
)

from qb2.api.v1 import filters as sf
from qb2.api.v1 import QB2, extractors as se
import pandas as pd
import datetime
import numpy as np
import re
import requests
startdate = datetime.datetime.now() - datetime.timedelta(days=2)
enddate = startdate + datetime.timedelta(days=1)
startdate = str(startdate).split(' ')[0]
enddate = str(enddate).split(' ')[0]
cluster = clusters.Hahn(pool='mobile-research', token='a6575e1e15b0475fb8d8564beaa60f23').env(
    templates=dict(
        job_root='home/turkey-analytics/ktereshin',
        dates='{2016-07-19}'
    )
)
def platform(x,y):
    if 'window' in str(x).lower() and (y==None or y==''):
        return 5746
    elif 'android' in str(x).lower() and (y==None or y==''):
        return 10321
    elif 'ios' in str(x).lower() and (y==None or y==''):
        return 42989
    else:
        return y
job = cluster.job()
search = job.table('$job_root/searches_money/searches_money_install_new_old')
search = search.project('media_source','project', 'media_source_type', 'channel_type', 'week', 'new_week', 'revenue', 'searches', 'browser', 'device_id', platform = ne.custom(lambda x: str(x).lower(),'platform')).filter(nf.custom(lambda x: x>0, 'searches'))
search = search.groupby('media_source','project', 'browser', 'platform', 'media_source_type', 'channel_type', 'week', 'new_week', 'device_id').aggregate(revenue = na.sum('revenue'), searches = na.sum('searches'))
search = search.groupby('media_source','project', 'browser', 'platform', 'media_source_type', 'channel_type', 'week', 'new_week').aggregate(revenue = na.sum('revenue'), searches = na.sum('searches'), users=na.count())
search = search.project('media_source','project', 'browser', 'platform', 'media_source_type', 'channel_type',  'searches', 'revenue', 'users',new_day = 'new_week', fielddate = 'week')
search = search.put('$job_root/searches_money/searches_money_install_new_old_by_week')
job.run()
result_data = search.read().as_dataframe().fillna(0)
res_data = pd.DataFrame(result_data.groupby(['media_source','fielddate','channel_type','media_source_type','new_day'])[['revenue', 'searches', 'users']].sum()).reset_index()
res_data = res_data.append(pd.DataFrame(result_data.groupby(['fielddate','project', 'browser', 'platform','channel_type', 'media_source','media_source_type'])[['revenue', 'searches', 'users']].sum()).reset_index())
res_data = res_data.append(pd.DataFrame(result_data.groupby(['fielddate','project', 'browser', 'platform','channel_type', 'media_source','new_day'])[['revenue', 'searches', 'users']].sum()).reset_index())
res_data = res_data.append(pd.DataFrame(result_data.groupby(['fielddate','project', 'browser', 'platform','channel_type', 'media_source_type','new_day'])[['revenue', 'searches', 'users']].sum()).reset_index())
res_data = res_data.append(pd.DataFrame(result_data.groupby(['fielddate','project', 'browser', 'platform','channel_type', 'media_source'])[['revenue', 'searches', 'users']].sum()).reset_index())
res_data = res_data.append(pd.DataFrame(result_data.groupby(['fielddate','project', 'browser', 'platform','channel_type', 'new_day'])[['revenue', 'searches', 'users']].sum()).reset_index())
res_data = res_data.append(pd.DataFrame(result_data.groupby(['fielddate','project', 'browser', 'platform','channel_type', 'media_source_type'])[['revenue', 'searches', 'users']].sum()).reset_index())
res_data = res_data.append(pd.DataFrame(result_data.groupby(['fielddate','project', 'browser', 'platform','channel_type'])[['revenue', 'searches', 'users']].sum()).reset_index())
res_data = res_data.fillna('total')
res_data = pd.DataFrame(res_data.groupby(['fielddate','channel_type','media_source_type','new_day', 'project', 'browser', 'platform', 'media_source'])[['revenue', 'searches', 'users']].mean()).reset_index()
def conv_money(x):
    try:
        return float(x)*30/1000000
    except:
        return 0
res_data['revenue'] = res_data['revenue'].apply(conv_money)
csv_data = re.sub('\n$', '', res_data.to_csv(sep=';', index=False))
r = requests.post(
    'https://upload.stat.yandex-team.ru/_api/report/data',
    headers={'StatRobotUser': 'robot_ktereshin', 'StatRobotPassword': '3en5cayAppeif6l'},
    data={
        'name': 'Distribution/ktereshin/money_searches/search_money_new_old',
        'scale': 'w',
        'data': csv_data,
    },
)
